; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518;400
Texture struct
	imageData dd ?; Image Data (Up To 32 Bits)
	bpp	dd ?; Image Color Depth In Bits Per Pixel
	width_	dd ?; Image Width
	height	dd ?; Image Height
	texID	dd ?; Texture ID Used To Select A Texture
	type_	dd ?; Image Type (GL_RGB, GL_RGBA)	
Texture ends

TGAHeader struct
 Header db 12 dup(?);		 TGA File Header
TGAHeader ends

TGA struct
	header		db 6 dup(?); First 6 Useful Bytes From The Header
	bytesPerPixel	dd ?;	 Holds Number Of Bytes Per Pixel Used In The TGA File
	imageSize	dd ?;	 Used To Store The Image Size When Setting Aside Ram
	temp		dd ?;	 Temporary Variable
	type_		dd ?;
	Height		dd ?;	Height of Image
	Width_		dd ?;	Width ofImage
	Bpp		dd ?;	 Bits Per Pixel
TGA ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	hFile:dword
local	FSize:dword
local	pMemory1:dword
local	pMemory2:dword
local	szReadWrite:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL

wmTIMER:movss	xmm0,spin
	addss	xmm0,const0_05; Increase Spin
	movss	spin,xmm0
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;-------------------------------------------------------
	mov	ecx,offset FileName1
        invoke	CreateFile,,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,rbx,rbx
	mov	hFile,eax
        invoke	GetFileSize,eax,0
        inc	eax
	mov	FSize,eax
        invoke	GlobalAlloc,GPTR,eax
        mov	pMemory1,eax
	mov	r8d,FSize
	dec	r8d
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,,,rbx
	invoke	CloseHandle,hFile
	mov	esi,offset uTGAcompare
	mov	edi,pMemory1
	mov	ecx,3
        repe	cmpsd
        jnz	@f
	mov	ecx,pMemory1
	invoke	LoadUncompressedTGA
@@:	mov	ecx,offset FileName2
        invoke	CreateFile,,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,rbx,rbx
	mov	hFile,eax
        invoke	GetFileSize,eax,0
        inc	eax
	mov	FSize,eax
        invoke	GlobalAlloc,GPTR,eax
        mov	pMemory2,eax
	mov	r8d,FSize
	dec	r8d
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,,,rbx
	invoke	CloseHandle,hFile
	mov	esi,offset cTGAcompare
	mov	edi,pMemory2
	mov	ecx,3
        repe	cmpsd
	mov	ecx,pMemory2
	invoke	LoadCompressedTGA

	xor	esi,esi
@@:	lea	edx,texture[rsi].texID
	invoke	glGenTextures,1; Create The Texture ( CHANGE )
	mov	edx,texture[rsi].texID
	invoke	glBindTexture,GL_TEXTURE_2D
	mov	r8d,texture[rsi].bpp
	shr	r8d,3
	mov	r9d,texture[rsi].width_
	mov	eax,texture[rsi].height
	mov	[rsp+20h],rax
	mov	eax,texture[rsi].type_
	mov	[rsp+30h],rax
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	eax,texture[rsi].imageData
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,0,,,,rdx
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	add	esi,sizeof Texture
	cmp	esi,(sizeof Texture)*2
	jb	@b
	mov	ecx,texture.imageData
	invoke	GlobalFree
;	mov	ecx,texture1.imageData
;	invoke	GlobalFree

	invoke	glEnable,GL_TEXTURE_2D	; Enable Texture Mapping ( NEW )
	invoke	glShadeModel,GL_SMOOTH	; Enable Smooth Shading
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;(0.0f, 0.0f, 0.0f, 0.5f); Black Background
	cvtss2sd xmm0,const1
	invoke	glClearDepth	; Depth Buffer Setup
	invoke	glEnable,GL_DEPTH_TEST	; Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL	; The Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Really Nice Perspective Calculations
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	invoke	glLoadIdentity		; Reset The Modelview Matrix
	movss	xmm2,const_10
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;(0.0f,0.0f,-10.0f);	; Translate 20 Units Into The Screen

	xor	esi,esi
@@:	invoke	glPushMatrix	; Push The Matrix
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	cvtsi2ss xmm0,esi
	mulss	xmm0,const18
	addss	xmm0,spin
	invoke	glRotatef;(spin+loop*18.0f,1.0f,0.0f,0.0f); Rotate On The X-Axis (Up - Down)
	xorps	xmm2,xmm2
	movss	xmm1,const2
	movss	xmm0,const_2
	invoke	glTranslatef;(-2.0f,2.0f,0.0f);; Translate 2 Units Left And 2 Up
	mov	edx,texture.texID
	invoke	glBindTexture,GL_TEXTURE_2D;			// ( CHANGE )
	invoke	glBegin,GL_QUADS	; Draw Our Quad
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0.0f, 1.0f); 
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,const_1
	invoke	glVertex3f;(-1.0f,  1.0f, 0.0f);
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f); 
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f;( 1.0f,  1.0f, 0.0f);
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f); 
	xorps	xmm2,xmm2
	movss	xmm1,const_1
	movss	xmm0,const1
	invoke	glVertex3f;( 1.0f, -1.0f, 0.0f);
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f); 
	xorps	xmm2,xmm2
	movss	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f;-1,-1,0
	invoke	glEnd			; Done Drawing The Quad
	invoke	glPopMatrix		; Pop The Matrix

	invoke	glPushMatrix		; Push The Matrix
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const2
	invoke	glTranslatef;2,0,0 Translate 2 Units To The Right
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	cvtsi2ss xmm0,esi
	mulss	xmm0,const36
	addss	xmm0,spin
	invoke	glRotatef;spin+loop*36,0,1,0	 Rotate On The Y-Axis (Left - Right)
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTranslatef;1,0,0 Move One Unit Right
	mov	edx,texture1.texID
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glBegin,GL_QUADS; Draw Our Quad
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f); 
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,const_1
	invoke	glVertex3f;(-1.0f,  1.0f, 0.0f);
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f); 
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f;( 1.0f,  1.0f, 0.0f);
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f); 
	xorps	xmm2,xmm2
	movss	xmm1,const_1
	movss	xmm0,const1
	invoke	glVertex3f;( 1.0f, -1.0f, 0.0f);
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f); 
	xorps	xmm2,xmm2
	movss	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f;(-1.0f, -1.0f, 0.0f);
	invoke	glEnd; Done Drawing The Quad
	invoke	glPopMatrix; Pop The Matrix
	inc	esi
	cmp	esi,20
	jb	@b
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn
WndProc	endp
LoadUncompressedTGA proc textur:dword;, char * filename, FILE * fTGA)	// Load an uncompressed TGA (note, much of this code is based on NeHe's 
	mov	textur,ecx
	push	rsi
	push	rdi
	add	ecx,sizeof TGAHeader
	movzx	eax,word ptr [rcx]
	mov     tga.Width_,eax
	mov	texture.width_,eax
	movzx	eax,word ptr [rcx+2]
	mov     tga.Height,eax
	mov	texture.height,eax
	movzx	eax,word ptr [rcx+4]
	mov     tga.Bpp,eax
	mov	texture.bpp,eax
	shr	eax,3
	mov     tga.bytesPerPixel,eax
	cmp	eax,3
	je	@f
	mov	texture.type_,GL_RGBA
	jmp	@0
@@:     mov	texture.type_,GL_BGR_EXT
@0:	mul	tga.Width_
	mul	tga.Height
	mov	tga.imageSize,eax
        invoke	GlobalAlloc,GPTR,eax
	mov	texture.imageData,eax
	mov	edi,eax
	mov	esi,textur
	add	esi,sizeof TGAHeader+6
	mov	ecx,tga.imageSize
	shr	ecx,3
	rep	movsq
	mov	ecx,textur
	invoke	GlobalFree
	pop	rdi
	pop	rsi
	leave
	ret
LoadUncompressedTGA endp
LoadCompressedTGA proc textur:dword; Load COMPRESSED TGAs
local	currentpixel:dword
local	pixelcount:dword

	mov	textur,ecx
	push	rsi
	push	rdi
	and	currentpixel,0; Current pixel being read
	add	ecx,sizeof TGAHeader
	movzx	eax,word ptr [rcx]
	mov     tga.Width_,eax
	mov	texture1.width_,eax
	movzx	eax,word ptr [rcx+2]
	mov     tga.Height,eax
	mov	texture1.height,eax
	mul	tga.Width_
	mov	pixelcount,eax;	pixelcount = tga.Height * tga.Width; Nuber of pixels in the image

	mov	esi,textur
	add	esi,(sizeof TGAHeader+6);18

	movzx	eax,byte ptr [rcx+4]
	mov     tga.Bpp,eax
	mov	texture1.bpp,eax ;
	shr	eax,3
	mov     tga.bytesPerPixel,eax
	cmp	eax,3
	je	@6
	mov	texture1.type_,GL_RGBA

	mul	tga.Width_
	mul	tga.Height
	mov	tga.imageSize,eax
        invoke	GlobalAlloc,GPTR,eax
	mov	texture1.imageData,eax
	mov	edi,eax
	mov	edx,pixelcount
@4:	lodsb
	cmp	al,80h
	jb	@f
	sub	al,7Fh
	movzx	ecx,al
	jmp	@5
@@:     inc	al
	movzx	ecx,al
	add	currentpixel,ecx
	sub	esi,3
	rep	movsd
	jmp	@9
@5:     lodsd
	rep	stosd
@9:	cmp	currentpixel,edx
	jb	@4
	jmp	exit0
@6:     mov	texture1.type_,GL_BGR_EXT
	mul	tga.Width_
	mul	tga.Height
	mov	tga.imageSize,eax
        invoke	GlobalAlloc,GPTR,eax
	mov	texture1.imageData,eax
	mov	edi,eax 
	mov	edx,pixelcount
@2:	lodsd
	cmp	al,80h
	jb	@f
	sub	al,7Fh
	movzx	ecx,al
	jmp	@7
@@:     inc	al
	movzx	ecx,al
	add	currentpixel,ecx
	imul	ecx,tga.bytesPerPixel
	sub	esi,3
	rep 	movsb
	jmp	@8
@7:	add	currentpixel,ecx
	ror	eax,8
@1:	stosd
	dec	edi
	loop	@1
@8:	cmp	currentpixel,edx
	jb	@2
exit0:	mov	ecx,textur
	invoke	GlobalFree
	pop	rdi
	pop	rsi
	leave
	ret
LoadCompressedTGA endp
;------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	24;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #33: TGA Loading Tutorial",0
FileName	db "br_Rabbit3.cur",0
FileName1	db "Uncompressed.tga",0
FileName2	db "Compressed.tga",0
spin		dd ?
tgaheader	TGAHeader <>; TGA header
tga		TGA <>; TGA image data
uTGAcompare	db 0,0,2, 9 dup(0); Uncompressed TGA Header
cTGAcompare	db 0,0,10,9 dup(0); Compressed TGA Header
texture 	Texture <>
texture1 	Texture <>; storage for 2 textures 
;-----------------------------
;float
const0_05	dd 0.05
const0_5	dd 0.5
const1		dd 1.0
const_1		dd -1.0
const2		dd 2.0
const_2		dd -2.0
const_10	dd -10.0
const18		dd 18.0
const36		dd 36.0
;double
constd1		dq 1.0
constd45	dq 45.0
constd100	dq 100.0
end